package com.cretin.webdb.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * APP国际化翻译表
 * </p>
 *
 * @author Cretin
 * @since 2024-01-09
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class TbV2StrTranslateItem implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * key
     */
    private String itemKey;

    /**
     * 内容
     */
    private String itemSource;

    /**
     * 渠道内容 比如 values
     */
    private String itemChannel;

    private LocalDateTime addTime;

    private LocalDateTime updateTime;

    /**
     * app_id
     */
    private Integer appId;

    /**
     * 内容所处模块
     */
    private String itemModule;

    /**
     * 是否可用
     */
    private Boolean deleteFlag;


}
