package com.cretin.webdb.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * APP国际化翻译项目配置表
 * </p>
 *
 * @author Cretin
 * @since 2024-01-19
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class TbV2StrTranslateProject implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 项目id
     */
    private String projectName;

    /**
     * 项目配置 json
     */
    private String projectLocationConfig;

    /**
     * 渠道配置 字符串数组
     */
    private String channelConfig;

    /**
     * 主要渠道
     */
    private String projectChannel;

    /**
     * 项目所属用户id
     */
    private Integer userId;

    private LocalDateTime addTime;

    private LocalDateTime updateTime;

    /**
     * 被隐藏的渠道 字符串数组
     */
    private String channelHideConfig;

    /**
     * 描述
     */
    private String shortDesc;

    /**
     * 渠道名称配置
     */
    private String channelConfigName;

    /**
     * 平台
     */
    private String projectPlatform;

    /**
     * 项目备份 json
     */
    private String projectBackupConfig;

    /**
     * 项目模块 字符串数组
     */
    private String projectModuleConfig;

    private LocalDateTime lastUploadTime;


}
